//#define DEBUG
//+------------------------------------------------------------------+
//|                                                    FxCalcNo1.mq4 |
//|                                                          mwfx108 |
//|                                                mwfx108@gmail.com |
//+------------------------------------------------------------------+
#property copyright "mwfx108"
#property link      "mwfx108@gmail.com"
#property version   "1.16"
#property strict
#property indicator_chart_window
//+------------------------------------------------------------------+
//| License Stuff                                                    |
//+------------------------------------------------------------------+
#ifdef DEBUG
int      _acctNumber = 96087405;          // -1 = Allow any account
datetime _expDate = D'2019.09.30';  // Expiration date (yyyy.mm.dd)
#else
int      _acctNumber = -1;          // -1 = Allow any account
datetime _expDate = D'2019.12.31';  // Expiration date (yyyy.mm.dd)
#endif
//+------------------------------------------------------------------+
//| DO NOT CHANGE ANYTHING BELOW HERE - UNLESS YOU KNOW WHAT YOU DO! |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Includes                                                         |
//+------------------------------------------------------------------+
#include <mwfx108/BaseLevels.mqh>
#include <mwfx108/ChartTools.mqh>
#include <mwfx108/FxCalcNo1.mqh>
//+------------------------------------------------------------------+
//| Inputs                                                           |
//+------------------------------------------------------------------+
extern string sep1                        = "==== Bias ====";              // Bias Colors
extern color Color_Bias_Buy               = clrAqua;                       // Buy
extern color Color_Bias_Sell              = clrRed;                        // Sell
extern string sep2                        = "==== NY Close ====";          // NY Close Line
extern color Color_NYC                    = clrSkyBlue;                    // Color
extern ENUM_LINE_STYLE Style_NYC          = STYLE_SOLID;                   // Style
extern int Width_NYC                      = 1;                             // Width
extern string sep3                        = "==== Pivot ====";             // Pivot Line
extern color Color_Pivot                  = clrYellow;                     // Color
extern ENUM_LINE_STYLE Style_Pivot        = STYLE_SOLID;                   // Style
extern int Width_Pivot                    = 1;                             // Width
extern string sep4                        = "==== Sentiment ====";         // Sentiment Line
extern color Color_Sentiment              = clrOrange;                     // Color
extern ENUM_LINE_STYLE Style_Sentiment    = STYLE_SOLID;                   // Style
extern int Width_Sentiment                = 1;                             // Width
extern string sep5                        = "==== NMH ====";               // NMH Line
extern color Color_NMH                    = clrCyan;                       // Color
extern ENUM_LINE_STYLE Style_NMH          = STYLE_SOLID;                   // Style
extern int Width_NMH                      = 1;                             // Width
extern string sep6                        = "==== Sell Entries ====";      // Sell Levels
extern color Color_Sell_Entries           = clrRed;                        // Color
extern ENUM_LINE_STYLE Style_Sell_Entries = STYLE_SOLID;                   // Style
extern int Width_Sell_Entries             = 1;                             // Width
extern string sep7                        = "==== Sell Targets ====";      // Sell Targets
extern color Color_Sell_Targets           = clrCrimson;                    // Color
extern ENUM_LINE_STYLE Style_Sell_Targets = STYLE_SOLID;                   // Style
extern int Width_Sell_Targets             = 1;                             // Width
extern string sep8                        = "==== Buy Entries ====";       // Buy Levels
extern color Color_Buy_Entries            = clrBlue;                       // Color
extern ENUM_LINE_STYLE Style_Buy_Entries  = STYLE_SOLID;                   // Style
extern int Width_Buy_Entries              = 1;                             // Width
extern string sep9                        = "==== Buy Targets ====";       // Buy Targets
extern color Color_Buy_Targets            = clrAliceBlue;                  // Color
extern ENUM_LINE_STYLE Style_Buy_Targets  = STYLE_SOLID;                   // Style
extern int Width_Buy_Targets              = 1;                             // Width
extern string sep10                       = "==== LBO Levels ====";        // LBO Levels
extern color Color_LBO_Levels             = clrBrown;                      // Color
extern ENUM_LINE_STYLE Style_LBO_Levels   = STYLE_SOLID;                   // Style
extern int Width_LBO_Levels               = 1;                             // Width
extern string sep11                       = "==== HBO Levels ====";        // HBO Levels
extern color Color_HBO_Levels             = clrAliceBlue;                  // Color
extern ENUM_LINE_STYLE Style_HBO_Levels   = STYLE_SOLID;                   // Style
extern int Width_HBO_Levels               = 1;                             // Width
extern string sep12                       = "==== Display Settings ====";  // Settings
extern ENUM_DISPLAY_MODE Display_Mode     = Bias_Levels;                   // Display Mode
extern bool Show_Break_Lines              = FALSE;                         // Show break levels
extern string sep13                       = "==== Break Levels ====";      // Break Levels
extern color Color_Break_Levels           = clrBurlyWood;                  // Color
extern ENUM_LINE_STYLE Style_Break_Levels = STYLE_DASH;                    // Style
extern int Width_Break_Levels             = 1;                             // Width
//+------------------------------------------------------------------+
//| Variables                                                        |
//+------------------------------------------------------------------+
ENUM_INSTRUMENTS _instrument = Invalid;
double _nyClose;
ENUM_ORDER_TYPE _bias;
BaseLevel _levels[];
int _lastAcctNumber = 0;
int _acctValid = 0;
#ifdef DEBUG
int _debugLogHandle = INVALID_HANDLE;
#endif
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
//--- indicator buffers mapping

   MathSrand(GetTickCount());
   _acctValid = MathRand();
   
#ifdef DEBUG
   ResetLastError();
   _debugLogHandle = FileOpen("FxCalcDebug_" + _Symbol + ".log", FILE_TXT|FILE_SHARE_READ|FILE_READ|FILE_WRITE );
   if (_debugLogHandle == INVALID_HANDLE)
      Alert(StringFormat("ERROR: Can't open file FxCalcDebug_" + _Symbol + ".log (%d)", GetLastError()));
#endif

//---
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
//---

   Comment("");
   
   ArrayFree(_levels);

   RemoveObjects();

#ifdef DEBUG
   if (_debugLogHandle != INVALID_HANDLE)
      FileClose(_debugLogHandle);
#endif
   
//---
}
//+------------------------------------------------------------------+
//| Custom indicator chart event                                     |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long& lparam,
                  const double& dparam,
                  const string& sparam)
{
//---

   if (id == CHARTEVENT_CLICK || id == CHARTEVENT_CHART_CHANGE)
   {
      double currentPrice = iClose(_Symbol, PERIOD_D1, 0);
      DrawLevels(_nyClose, currentPrice, _levels, _bias,
         Display_Mode, Show_Break_Lines);
   }

//---
}                  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
//---

   Process();
   
//--- return value of prev_calculated for next call
   return(rates_total);
}
//+------------------------------------------------------------------+
//| Check account number and expiration date.                        |
//+------------------------------------------------------------------+
void CheckLicense()
{
//---

   if (TimeCurrent() >= _expDate)
   {
      _acctValid = MathRand();
      
      string message = "This indicator has expired. Please visit www.fxcalcno1.com to download an update or for more information!";
      Print(message);
      Comment(message);
      
      return;
   }
   
   static bool stateChanged = TRUE;
   int currentAcctNumber = AccountNumber();
   if (!IsConnected() || currentAcctNumber == 0)
   {
      Comment("");
      stateChanged = TRUE;
      _acctValid = MathRand();
      return;
   }
   
   if (currentAcctNumber != _lastAcctNumber)
   {
      _lastAcctNumber = currentAcctNumber;
      _acctValid = MathRand();
      stateChanged = TRUE;
   }

   if (_acctValid < 32768)
   {
      if (currentAcctNumber == _acctNumber || _acctNumber == -1)
      {
         Comment("");
         _acctValid = MathRand() + 32768;
         stateChanged = FALSE;
      }
      else
      {
         if (stateChanged)
         {
            stateChanged = FALSE;
            RemoveObjects();
            
            string message = "Wrong account number. Please visit www.fxcalcno1.com for more information!";
            Print(message);
            Comment(message);
         }
         _acctValid = MathRand();
         return;
      }
   }
   
//---
}
//+------------------------------------------------------------------+
//| Perform calculation and drawing                                  |
//+------------------------------------------------------------------+
void Process()
{
//---

   if (Period() >= PERIOD_D1)
      return;

   CheckLicense();
   if (_acctValid < 32768)
   {
      RemoveObjects();
      return;
   }

   _instrument = GetInstrument(_Symbol);
   if (_instrument == Invalid)
   {
      Comment(StringFormat("Pair \"%s\" is not supported!", _Symbol));
      return;
   }

   static datetime lastCheckTime = 0;
   datetime openTime = iTime(_Symbol, PERIOD_D1, 0);
   double currentPrice = iClose(_Symbol, PERIOD_D1, 0);
   
   double nmh = 0.0;
   for (int i = 0; i < ArraySize(_levels); i++)
   {
      if (_levels[i].type == LEVEL_NMH)
      {
         nmh = _levels[i].price;
         break;
      }
   }
   
#ifdef DEBUG
   datetime currentTime = TimeCurrent();
   Log(StringFormat("Open = %d (%s);\nLast = %d (%s);\nCurrent = %d (%s);\nDiff = %d (%d);\nNext = %d (%s).",
      openTime, TimeToStr(openTime), lastCheckTime, TimeToStr(lastCheckTime), currentTime, TimeToStr(currentTime),
      openTime - lastCheckTime, openTime + PeriodSeconds(PERIOD_D1) - currentTime,
      openTime + PeriodSeconds(PERIOD_D1), TimeToStr(openTime + PeriodSeconds(PERIOD_D1))));
#endif
   
   if (openTime > lastCheckTime || currentPrice > nmh)
   {
#ifdef DEBUG
      Log("License ok.");
      Log(StringFormat("Instrument %s (%s) ok.", _Symbol, EnumToString(ENUM_INSTRUMENTS(_instrument))));
      Log(StringFormat("Open time = %s; Last check time = %s.", TimeToStr(openTime), TimeToStr(lastCheckTime)));
#endif
   
      RemoveObjects();
      
      _nyClose = iClose(_Symbol, PERIOD_D1, 1);
      lastCheckTime = openTime;

#ifdef DEBUG
      Log("Calculating.");
      Log(StringFormat("NY Close price = %f.", _nyClose));
#endif

      ArrayFree(_levels);
      GetLevels(_Symbol, _nyClose, _bias, _levels);
      DrawBiasInformation(_bias == OP_BUY);
      
      Log("Done.");
      Log("Drawing.");
   }

   DrawLevels(_nyClose, currentPrice, _levels, _bias,
      Display_Mode, Show_Break_Lines);
      
//---
}
//+------------------------------------------------------------------+
//| Write to log file                                                |
//+------------------------------------------------------------------+
void Log(string message)
{
//---

#ifdef DEBUG
   if (_debugLogHandle != INVALID_HANDLE)
      FileWrite(_debugLogHandle, message);
#endif

//---
}
//+------------------------------------------------------------------+
